
package de.ivu.elect.presentation.dokumente;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.dokumente.boundary.DokumentVorlageBoundaryCreate;
import de.ivu.elect.business.dokumente.entity.DokumentVorlage;
import de.ivu.elect.business.dokumente.entity.DokumentVorlageMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractDokumentVorlageCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractDokumentVorlageCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.DOKUMENT_VORLAGE_CREATE)
public abstract class AbstractDokumentVorlageCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<DokumentVorlage> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "dokumentVorlageCreateView";

  public static final String VIEW_ID = "/dokumente/dokument-vorlage-create.xhtml";

  public static final String PARENT_VIEW_ID = "/dokumente/dokument-vorlage-search.xhtml";

  @Inject
  protected transient DokumentVorlageBoundaryCreate create;

  protected DokumentVorlage entity;

  @Inject
  protected transient DokumentVorlageMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  DokumentVorlage());
  }

  

  public DokumentVorlage getEntity() {
    return entity;
  }

  protected void setEntity(DokumentVorlage entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.DOKUMENT_VORLAGE_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(DokumentVorlage entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(DokumentVorlage entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.DOKUMENT_VORLAGE_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
